<?php
/**
*
* @package mcp
*
* @author evil3 (2008)
* @author Kazekage (2013)
* @copyright (c) 2013 Kazekage
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package mcp
*/
class mcp_troll
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $cache, $troll_mod;
		global $phpbb_root_path, $phpEx;
		
		$user->add_lang('mods/info_mcp_troll');
		$this->tpl_name = 'mcp_troll';
		$this->page_title = $user->lang['MCP_TROLL'];

		$trollsubmit		= (isset($_POST['trollsubmit'])) ? true : false;
		$untrollsubmit	= (isset($_POST['untrollsubmit'])) ? true : false;
		
		$form_key = 'mcp_troll';
		add_form_key($form_key);

		if (($trollsubmit || $untrollsubmit) && !check_form_key($form_key))
		{
			trigger_error($user->lang['FORM_INVALID'] . '<br /><br /><a href="' . $this->u_action . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>', E_USER_WARNING);
		}

		// Troll submitted?
		if ($trollsubmit)
		{
			$usernames = utf8_normalize_nfc(request_var('troll', '', true));
			if (!$usernames)
			{
				trigger_error($user->lang['NO_TROLL'] . '<br /><br /><a href="' . $this->u_action . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>', E_USER_WARNING);
			}
			$usernames = explode("\n", $usernames);
			
			if (!function_exists('user_get_id_name'))
			{
				include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
			}
			user_get_id_name($user_id, $usernames, array(0));
			
			if (!sizeof($user_id))
			{
				trigger_error($user->lang['NO_USER_TROLL'] . '<br /><br /><a href="' . $this->u_action . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>', E_USER_WARNING);
			}
			
			$troll_mod->add_troll( (array) $user_id);
			
			// logs
			add_log('admin', 'LOG_TROLL_ADD', implode(', ', $usernames));
			add_log('mod', 0, 0, 'LOG_TROLL_ADD', implode(', ', $usernames));
			foreach ($user_id as $troll_id)
			{
				add_log('user', $troll_id, 'LOG_TROLL_ADD',  implode(', ', $usernames));
			}
			
			trigger_error($user->lang['TROLL_UPDATE_SUCCESSFUL'] . '<br /><br /><a href="' . $this->u_action . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>');
		}
		else if ($untrollsubmit)
		{
			$user_id = request_var('untroll', array(0 => ''));

			if (!sizeof($user_id))
			{
				trigger_error($user->lang['NO_TROLL'] . '<br /><br /><a href="' . $this->u_action . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>', E_USER_WARNING);
			}
			
			$sql = 'SELECT u.username, u.user_id
				FROM ' . TROLLS_TABLE . ' t, ' . USERS_TABLE . ' u
				WHERE ' . $db->sql_in_set('t.troll_id', $user_id) .
				' AND t.user_id = u.user_id';
			$result = $db->sql_query($sql);
			
			$usernames = array();
			while ($row = $db->sql_fetchrow($result))
			{
				$usernames[] = $row['username'];
				add_log('user', $row['user_id'], 'LOG_TROLL_DEL',  $row['username']);
			}
			$db->sql_freeresult($result);
			
			// logs
			add_log('admin', 'LOG_TROLL_DEL', implode(', ', $usernames));
			add_log('mod', 0, 0, 'LOG_TROLL_DEL', implode(', ', $usernames));
		
			$troll_mod->delete_troll($user_id);
			trigger_error($user->lang['TROLL_UPDATE_SUCCESSFUL'] . '<br /><br /><a href="' . $this->u_action . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>');
		}
		
		// select all trolls
		$sql = 'SELECT t.troll_id, u.user_id, u.username, u.username_clean
			FROM ' . TROLLS_TABLE . ' t, ' . USERS_TABLE . ' u
			WHERE u.user_id = t.user_id
			ORDER BY u.username_clean ASC';
		$result = $db->sql_query($sql);

		$troll_options = '';
		while ($row = $db->sql_fetchrow($result))
		{
			$troll_options .= '<option value="' . $row['troll_id'] . '">' . $row['username'] . '</option>';
		}
		$db->sql_freeresult($result);

		// template vars
		$template->assign_vars(array(
			'L_TITLE'				=> $this->page_title,

			'TROLL_OPTIONS'			=> $troll_options,

			'U_ACTION'				=> $this->u_action,
			'U_FIND_USERNAME'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=mcp_troll&amp;field=troll'),
		));
	}
}

?>