<?php
/**
 *
 * @author evil3 (2008)
 * @author Kazekage (2013)
 * @copyright (c) 2013 Kazekage
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */

/**
 * @ignore
 */
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();


if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'TROLL_MOD';

/*
* The name of the config variable which will hold the currently installed version
* UMIL will handle checking, setting, and updating the version itself.
*/
$version_config_name = 'troll_version';


// The language file which will be included when installing
$language_file = 'mods/troll_mod';


/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
//$logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'2.0.0' => array(
		
		'custom'	=> 'extra_function',

		'table_add' => array(
			array(TROLL_ACTIONS_TABLE, array(
					'COLUMNS'		=> array(
						'action_name'		=> array('VCHAR_UNI', ''),
						'action_enabled'		=> array('BOOL', 0),
						'action_settings'		=> array('TEXT', NULL),
					),
					'PRIMARY_KEY'	=> 'action_name',
					'KEYS'			=> array(
						'action_enabled'		=> array('INDEX', 'action_enabled'),
					),
				),
			),
		),
		
		'permission_add' => array(
			array('m_troll', 1),
		),

		'config_add' => array(
			array('troll_group', 0, 0),
			array('troll_group_main', 0, 0),
		),

		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'TROLL_MOD'),                    
			array('acp', 'TROLL_MOD',
				array(
					'module_basename'	=> 'troll',
					'module_langname'	=> 'ACP_TROLL_CONFIG',
					'module_mode'	=> 'config',
					'module_auth'		=> 'acl_a_troll',
				),
			),
			array('acp', 'TROLL_MOD',
				array(
					'module_basename'	=> 'troll',
					'module_langname'	=> 'ACP_TROLL_ACT',
					'module_mode'	=> 'manage',
					'module_auth'		=> 'acl_a_troll',
				),
			),
			array('mcp', 'MCP_BAN',
				array(
					'module_basename'	=> 'troll',
					'module_langname'	=> 'TROLL_MOD',
					'module_mode'	=> 'troll',
					'module_auth'		=> 'acl_m_troll',
				),
			),
		),
	),
);

// Include the UMIL Auto file, it handles the rest
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

function extra_function($action, $version)
{
	global $umil, $cache;
	
	$cache->purge();
	
	if ($action == 'uninstall')
	{
		$umil->table_remove(TROLLS_TABLE);
		
		$umil->config_remove('troll_chance');	
		$umil->config_remove('troll_virus');
		$umil->config_remove('troll_email');
		$umil->config_remove('troll_pm');
		$umil->config_remove('troll_post');

		$umil->permission_remove('a_troll');
	}
	else
	{
		if ($umil->table_exists(TROLL_ACTIONS_TABLE))
		{
			$umil->table_remove(TROLL_ACTIONS_TABLE);
		}
		
		if (!$umil->table_exists(TROLLS_TABLE))
		{
			$umil->table_add(TROLLS_TABLE, array(
					'COLUMNS'		=> array(
						'troll_id'		=> array('UINT', NULL, 'auto_increment'),
						'user_id'		=> array('UINT', 0),
					),
					'PRIMARY_KEY'	=> 'troll_id',
					'KEYS'			=> array(
						'user_id'		=> array('INDEX', 'user_id'),
					),
				)
			);
		}
		
		if ($umil->module_exists('acp', false, 'ACP_CAT_TROLL'))
		{
			$umil->module_remove('acp', 'ACP_TROLL_MANAGEMENT', 'ACP_TROLL');
			$umil->module_remove('acp', 'ACP_TROLL_MANAGEMENT', 'ACP_TROLL_CONFIG');
			$umil->module_remove('acp', 'ACP_CAT_TROLL', 'ACP_TROLL_MANAGEMENT');
			$umil->module_remove('acp', 0, 'ACP_CAT_TROLL');
		}
		
		if ($umil->config_exists('troll_chance'))
		{
			$umil->config_remove('troll_chance');	
		}	
			$umil->config_add('troll_chance', 50);	
			
		if (!$umil->config_exists('troll_virus'))
			$umil->config_add('troll_virus', 0);
			
		if (!$umil->config_exists('troll_email'))
			$umil->config_add('troll_email', 1);
		
		if (!$umil->config_exists('troll_pm'))
			$umil->config_add('troll_pm', 1);
			
		if (!$umil->config_exists('troll_post'))
			$umil->config_add('troll_post', 1);
		
		if (!$umil->permission_exists('a_troll'))
			$umil->permission_add('a_troll', true);
	}
	return true;
}